import { boot } from "quasar/wrappers";
import { createI18n } from "vue-i18n";
import { Cookies } from "quasar";

import messages from "src/i18n";

let language = Cookies.get("language");
if (!language) {
  language = "zh-CN";
}

if (language != "zh-CN" && language != "en-US") {
  language = "zh-CN";
}

Cookies.set("language", language);

const i18n = createI18n({
  locale: language,
  messages,
});

export default boot(({ app }) => {
  // Set i18n instance on app
  app.use(i18n);
});

export { i18n };
